local anim8 = require 'anim8'


-- scr = {w = lg.getWidth(), h = lg.getHeight()}

local w, h = lg.getDimensions()
scr = {w = w, h = h,t="full"}

hx = scr.w/2 - scr.w/5
hy = scr.h/3

fonts = {
default = lg.newFont("/fonts/OpenSans-Regular.ttf", 20),
title = lg.newFont("/fonts/OpenSans-Regular.ttf", 45),
infos = lg.newFont("/fonts/OpenSans-Regular.ttf", 16),
battle = lg.newFont("/fonts/OpenSans-Regular.ttf", 25)
}

-- INIT FUNCTIONS


function loadgraphics()
	lg.setFont(fonts.infos)	
	lg.setBackgroundColor(0,0,0)		
	mouse.img = lg.newImage("assets/ms2.png")
	lg.setDefaultFilter('nearest', 'nearest', 0)		
	
	bg0.img = lg.newImage("assets/bg0.png")
	bg1.img = lg.newImage("assets/bg1.png")
	bg2.img = lg.newImage("assets/bg2.png")
	
	user.img = lg.newImage("assets/pawn.png")
	
	-- a_user.img = lg.newImage("assets/action.png")
	-- local g = anim8.newGrid(403, 338, a_user.img:getWidth(), a_user.img:getHeight())
	-- au_idle = anim8.newAnimation(g('1-1', 1), 0.06)
	-- au_1 = anim8.newAnimation(g('2-2', 1), 0.5)
	-- au_2 = anim8.newAnimation(g('3-3', 1), 0.5)
	-- au_3 = anim8.newAnimation(g('4-4', 1), 0.5)
	-- au_list={au_1,au_2,au_3,au_idle}
	
	
	coins.img = lg.newImage("assets/coins.png")
	local g = anim8.newGrid(100, 100, coins.img:getWidth(), coins.img:getHeight())	

	
	-- animation coin dot--
	ani_c_dot_1_ = anim8.newAnimation(g('4-1', 1), 0.1)
	ani_c_dot_2_ = anim8.newAnimation(g('4-1', 2), 0.1)
	ani_c_dot_3_ = anim8.newAnimation(g('4-1', 3), 0.1)
	
	ani_c_dot_1 = ani_c_dot_1_:clone()
	ani_c_dot_2 = ani_c_dot_2_:clone()
	ani_c_dot_3 = ani_c_dot_3_:clone()
	
	ani_c_dot_list={ani_c_dot_1,ani_c_dot_2,ani_c_dot_3}
	
	ani2_c_dot_1 = anim8.newAnimation(g('1-4', 1), 0.1)
	ani2_c_dot_2 = anim8.newAnimation(g('1-4', 2), 0.1)
	ani2_c_dot_3 = anim8.newAnimation(g('1-4', 3), 0.1)
	ani2_c_dot_list={ani2_c_dot_1,ani2_c_dot_2,ani2_c_dot_3}
	
	
	--animation coin rect--
	ani_c_rect_0 = anim8.newAnimation(g('1-4', 4), 0.1)
	ani_c_rect_1 = anim8.newAnimation(g('1-4', 5), 0.1)
	ani_c_rect_2 = anim8.newAnimation(g('1-4', 6), 0.1)
	ani_c_rect_3 = anim8.newAnimation(g('1-4', 7), 0.1)
	ani_c_rect_4 = anim8.newAnimation(g('1-4', 8), 0.1)
	ani_c_rect_x = anim8.newAnimation(g('1-4', 9), 0.1)
	ani_c_rect_list={ani_c_rect_0,ani_c_rect_1,ani_c_rect_2,ani_c_rect_3,ani_c_rect_4,ani_c_rect_x}
	
	
	lg.setDefaultFilter('nearest', 'nearest', 0)
	
	--sound
	-- s_paper = love.audio.newSource("assets/paper.wav", "static")	
	
	-- music
	-- m_m1 = love.audio.newSource("assets/Jazz_Saxaphone.mp3", "static")	
	
	init()
end

function u(t)	
	--animation update	
	
	
	
	
	-- for i,acd in ipairs(ani_c_dot_list) do acd:update(t) end
	for i,a2cd in ipairs(ani2_c_dot_list) do a2cd:update(t) end	
	for i,acr in ipairs(ani_c_rect_list) do acr:update(t) end
	
	if act_timer == true then timer_ =  timer_ + 1*t end
	if act_timer == false then timer_ =  0 end	
	
	
	if gi.state == "ani_selected" then
		if ani_selected > 0 then ani_selected = ani_selected - 1*t end
		if ani_selected <= 0 then gi.state = "selected" ani_selected = 4 end
	end
	
	if gi.state == "result_tour" then
		resultour(t)
	end
	
	-- if gi.state == "ani_start" then
		-- if ani_start > 0 then ani_start = ani_start - 1*t end
		-- if ani_start <= 0 then gi.state = "tour" ani_start = 0.4 end
	-- end
	
	if gi.state == "ani_start" then
		if temps_ >	0 then temps_ = temps_ - 1*t end
		if temps_ <= 3 and #coin_set == 0 then rng_set_A() end
		if temps_ <= 2 and #coin_set == 1 then rng_set_B() end
		if temps_ <= 1 and #coin_set == 2 then rng_set_C() end
		if temps_ <= 0 and #coin_set == 3 then temps_ = 0 gi.state = "tour" end
		
		for i_, c_ in ipairs(coin_set) do			
			if c_.anim ~= nil then c_.anim:update(t)end		
			c_.anim = ani_c_dot_list[c_[1]]
			if c_[2] > 0 then c_[2] = c_[2] - 0.6*t end
			if c_[2] <= 0 then c_[2]=0 end
		end
	end
	
	
	
	
	-- test.sa = test.sa - 0.1*t
end

function draw()

lg.setColor(1,1,1,1)
-- lg.draw(bg1.img,bg1.x,bg1.y)
lg.setColor(0.2,0.2,0.2,1)
lg.rectangle("fill", 0, 0, 1920, 1080)


-- at_list[1]:draw(test.img, test.x+100, test.y,0,5,5,test.w,test.h)
-- lg.setColor(1,1,1,1)
-- lg.print("sa: "..test.sa,500,50)	

-- draw zone
lg.setColor(1,1,1,1)	
	-- debug --
	local x_ = 200
	local y_ = 40
	lg.setColor(1,1,1,1)
	lg.print("TIME: "..gi.vtime.."\nUSER < "..gi.vstr.." > CPU \nSTATE: "..gi.state.."\n"..user.sel[1].." - "..user.sel[2].."\n"..cpu.sel[1].." - "..cpu.sel[2],x_,y_)	
	lg.print("Timer: "..math.floor(gi.t).."/"..gi.tm.." (t_: "..gi.t_.." s_: "..gi.s_..")".."\ntemps_"..math.ceil(temps_).." / "..#coin_set,x_+200,y_)		
	
	--selected original list--
	-- lg.print(gi.a_,20,10)
	-- lg.print(gi.b_,20,30)
	-- lg.print(gi.c_,20,55)	
	
	--end debug--
	
	
	lg.setColor(1,1,1,1)
	
	--rng event button--
	local x_ = 500
	local y_ = 300
	local cM = {x=mouse.x,y=mouse.y,radius=10}	
	
	
	
	for i_, c_ in ipairs(coin_set) do
		
		-----------------------------------------------------------------------------------------------------------------------------------------DEBUG PROPER ANIMATION
		--- issue is that if coin that appear got the same c_[1] (and the animation is already ending in a previous coin) it's jump to the frame 4 ? ----
		
		if gi.state == "ani_start" or gi.state == "tour" or gi.state == "result_tour" then			
			lg.setColor(1,1,1,1)	
			if c_[2] > 0 then
				c_.anim:draw(coins.img,x_+(i_*150)-50,y_-50)			
				lg.print(c_.anim:getCurrentFrameCounter(),x_+(i_*150),y_+15)
				lg.print(c_[2],x_+(i_*150),y_)
			end
			if c_[2] <= 0 then
				c_.anim:draw(coins.img,x_+(i_*150)-50,y_-50)
				c_.anim:gotoFrame(4)
			end
		end		
		
		-- if gi.state == "ani_start" or gi.state == "tour" or gi.state == "result_tour" then
			-- lg.setColor(1,1,1,1)	
			-- if ani_c_dot_list[c_[1]]:getCurrentFrameCounter() < ani_c_dot_list[c_[1]]:getTotalFrameCounter() then
				-- ani_c_dot_list[c_[1]]:draw(coins.img,x_+(i_*150)-50,y_-50)			
				---- lg.print(ani_c_dot_list[c_[1]]:getCurrentFrameCounter(),x_+(i_*150),y_)
			-- end
			-- if ani_c_dot_list[c_[1]]:getCurrentFrameCounter() >= ani_c_dot_list[c_[1]]:getTotalFrameCounter() then
				-- ani_c_dot_list[c_[1]]:draw(coins.img,x_+(i_*150)-50,y_-50)
				-- ani_c_dot_list[c_[1]]:gotoFrame(4)
			-- end
		-- end		
		
		-- if gi.state == "tour" and #coin_set == 3 then
		if gi.state == "tour" then
			local cr = {x=x_+(i_*150),y=y_,radius=50}	
			lg.setColor(0.75,0.25,0,0.75)
			lg.print(c_[1],cr.x,cr.y+50)
			lg.setColor(1,1,1,1)			
			if CheckCollisionCircle(cr,cM,0)then
				lg.setColor(0.75,0.25,0,0.75)
				lg.circle("fill", cr.x, cr.y, cr.radius)
				if varselectmenu == true then	
					
					user.sel = c_					
					cpu_selection()			
					
					gi.t_ = user.sel[1] + cpu.sel[1]
					if user.sel[2] == "x" or cpu.sel[2] == "x" then
						gi.s_ =  "x"
					else				
						gi.s_ = user.sel[2] - cpu.sel[2]
					end

					-- resultour()						
					gi.state = "result_tour"					
				end
			else	
				lg.setColor(0.75,0.25,0,0.5)		
				lg.circle("line", cr.x, cr.y, cr.radius)
			end			
			
			-- lg.print(c_.s,cr.x,cr.y+100)	
		end
		
		
			
		
		-- if gi.state == "ani_selected" and user.i == i_ then
			-- lg.setColor(1,1,1,1)				
				-- if ani2_c_dot_list[user.sel[1]]:getCurrentFrameCounter() < ani2_c_dot_list[user.sel[1]]:getTotalFrameCounter() then
					-- ani2_c_dot_list[user.sel[1]]:draw(coins.img,x_+(i_*150)-50,y_-50)			
				-- end
				-- if ani2_c_dot_list[user.sel[1]]:getCurrentFrameCounter() >= ani2_c_dot_list[user.sel[1]]:getTotalFrameCounter() then
					-- ani2_c_dot_list[user.sel[1]]:draw(coins.img,x_+(i_*150)-50,y_-50)
					-- ani2_c_dot_list[user.sel[1]]:gotoFrame(4)
					-- gi.state = "selected"
				-- end			
		-- end
		
	
		
		
		
		
	end
	
	-- draw reverse --- 

	
	
	
	-- if gi.state == "ani_selected" then
		-- if user.sel[2] == 0 then ani_c_rect_list[5]:draw(coins.img,coins.x+(150),coins.y) end
		-- if user.sel[2] == "x" then ani_c_rect_list[6]:draw(coins.img,coins.x+(150),coins.y) end
		-- if user.sel[2] ~= "x" and user.sel[2] ~= 0 then	ani_c_rect_list[user.sel[2]]:draw(coins.img,coins.x+(150),coins.y) end
		
		-- if cpu.sel[2] == 0 then	ani_c_rect_list[5]:draw(coins.img,coins.x+(250),coins.y) end
		-- if cpu.sel[2] == "x" then ani_c_rect_list[6]:draw(coins.img,coins.x+(250),coins.y)	end
		-- if cpu.sel[2] ~= "x" and cpu.sel[2] ~= 0 then ani_c_rect_list[cpu.sel[2]]:draw(coins.img,coins.x+(250),coins.y) end	
	-- end	
	
	
	
	

		
	if gi.state == "end game" then 
		if gi.vstr < 0 then lg.print("user win !",500,500) end
		if gi.vstr > 0 then lg.print("cpu win !",500,500) end
		if gi.vstr == 0 then lg.print("Tie !",500,500) end
	end
	
	if gi.state == "end tour" then 
		endtour()
	end
	
	-- init game --
	if init_var == "none" then init() end			
	varselectmenu = false	

end

function init()		
	coin_list = coin_init_list
	shuffle(coin_list)		
	gi.state = "ani_start"		
	
end

function rng_set_A()
	-- RNG A
	gi.a_ = rng:random(1,#coin_list)	
	table.insert(coin_set,coin_list[gi.a_])
	if #coin_set == 1 then	table.remove(coin_list,gi.a_) end
end
function rng_set_B()
	-- RNG B
	gi.b_ = rng:random(1,#coin_list)
	if gi.b_ == gi.a_ then rng:random(1,#coin_list) end	
	table.insert(coin_set,coin_list[gi.b_])
	if #coin_set == 2 then table.remove(coin_list,gi.b_) end
end
function rng_set_C()
	-- RNG C
	gi.c_ = rng:random(1,#coin_list)
	if gi.c_ == gi.a_ or gi.c_ == gi.b_ then gi.c_ = rng:random(1,#coin_list) end	
	table.insert(coin_set,coin_list[gi.c_])
	if #coin_set == 3 then table.remove(coin_list,gi.c_) end
end

function cpu_selection()
	local r = rng:random(1,#coin_set)
	cpu.sel = coin_set[r]
end


----------------TODO:







function endgame()
	
end